
       SUBROUTINE INITIALIZE()
       PARAMETER (nradstep=350)
c       IMPLICIT none
       REAL hc,k
       REAL elamx(92,0:5),gfx(92,0:5),chix(92,0:5),taux(92,0:5,nradstep)
       REAL vphot,vmax,tauxold
       REAL tbb, onex
       REAL ea,eb,wk,pwrlawin,xsto
       REAL taumin,zeta,rmax,wzone
       INTEGER grid,jrlim,nlam,numref,i,j
       LOGICAL flambda,pwrlaw
       REAL alam,agf,aelow,stspec
       INTEGER anum,aion,ii,ij,ik
       INTEGER ai(50),an(50),begin,stop
       REAL  tau1(50),vmine(50),vmaxe(50),ve(50),temp(50)
       COMMON /param/ elamx,gfx,chix,taux,vphot,vmax,tbb,ea,eb
     a    ,taumin ,zeta,grid,jrlim,nlam,flambda,an,ai,numref,stspec
       integer iflat        ! Jeffery hack 2006jul08.
       common/flat/iflat
      NAMELIST   /parms/ ve ,
     A                   vphot, tbb, vmax, numref, ai, an,
     B                   ea, eb, taumin, grid, 
     C                   tau1,flambda,nlam,vmine,vmaxe,
     D                   zeta,temp,
     E                   stspec,pwrlaw,pwrlawin
     &                   ,iflat                                   ! Jeffery hack 2006jul08.
!
       iflat=0          ! 0 is default;  1 is for producing a locally normalized spectrum.  Jeffery hack 2006jul08.
!
       hc=12400.
       k=8.6167e-5
       onex=1.0
       PRINT *,'INITIALIZING'
c      READ IN REFERENCE LINE PARAMETERS
       OPEN(UNIT=1,
     & FILE='ref.dat',
     & STATUS='old')

 1    READ (1, 3, END=2)  alam, agf, anum, aion, aelow

 3    FORMAT  (F12.4, 1X, F6.3, 1X, I2, 2X, I1, 1X, F12.8)

      elamx(anum,aion) =  alam*10.0
      gfx(anum,aion)   =  agf*log(10.)
      chix(anum,aion)  =  aelow
      GOTO 1
 
C      READ IN PHYSICAL PARAMETERS
      
 2    OPEN  (UNIT=5, FILE= 'in.dat', STATUS='OLD')
 
      READ (5,parms)

      CLOSE (5)
      IF (pwrlaw) PRINT *,'POWER LAW OVERIDES ve'
      DO anum=1,92
        DO aion=0,5
         taux(anum,aion,1)=0.0
        ENDDO
      ENDDO 
      rmax     =  vmax/vphot
      tbb=tbb*k/hc
      jrlim=INT(rmax*real(grid)+.5)
C   NOW WE SET UP RADIAL PROFILES 
      DO j=1,numref
         vmine(j)=1000.*vmine(j)
         vmaxe(j)=1000.*vmaxe(j)
         ve(j)=1000.*ve(j)
         IF (vmine(j).le.vphot*1.001) THEN
           begin=grid+1
           wzone=.5
           vmine(j)=vphot
         ELSE
           begin=INT(1.5+REAL(grid)*(vmine(j)/vphot))
           wzone= .5*(1.0-(1.0 - (vmine(j)/vphot)**(-2))**.5)
           begin=MIN(begin,jrlim)
         ENDIF
         stop=INT(1.5+REAL(grid)*(vmaxe(j)/vphot))
         stop =MIN(stop,jrlim)
C   NOW WE SET UP THE optical depth profiles.
C   REMEMBER that we have to anticorrect for stimulated emmission.
         IF (elamx(an(j),ai(j)).lt.1000.) THEN
           PRINT *,'NEED ref.dat line for',an(j),ai(j)
           STOP
         ENDIF
         wk=(exp(1./tbb/elamx(an(j),ai(j)))-1.)/wzone/zeta/zeta+1.
         wk=1.-1./wk
         tauxold=taux(an(j),ai(j),1)
         taux(an(j),ai(j),1)=tau1(j)/wk
         taux(an(j),ai(j),2)=temp(j)*1000.*k
         DO i=begin,stop
           IF (pwrlaw) THEN
            xsto=max( onex, ( vphot/vmine(j)) )
            taux(an(j),ai(j),i)=taux(an(j),ai(j),1)
     a       *(xsto*real(i-1)/REAL(grid))**(-pwrlawin)
           ELSE

           taux(an(j),ai(j),i)=taux(an(j),ai(j),1)
     a       *exp((vmine(j)-vphot*real(i-1)/REAL(grid))/ve(j))
          ENDIF
         ENDDO
         taux(an(j),ai(j),1)=tauxold+taux(an(j),ai(j),1)
       ENDDO
C this part close packs the species in use
         ii=1
         DO ij=1,numref
          IF (tau1(ij).gt.0.0001*taumin) THEN
           DO ik=1,ii-1
            IF (ai(ik).eq.ai(ij).and.an(ik).eq.an(ij)) GOTO 200
           ENDDO
           ai(ii)=ai(ij)
           an(ii)=an(ij)
           tau1(ij)=0.0
           ii=ii+1
           ENDIF
 200     ENDDO
         numref=ii-1
   
       PRINT *, 'INITIALIZATION COMPLETE FOR ',numref,' SPECIES'  
       RETURN
       END
         


