
       SUBROUTINE SOURCE (elam,thisline,blueline,ctheta,black)
C   THIS SUBROUTINE CALCULATES THE MEAN INTENSITY ariving at a point
C    in the atmosphere.
C   IT THEN CALCULATES THE SOURCE FUNCTION AND OPTICAL DEPTH OF THIS LINE AT
C   THAT POINT.
       PARAMETER (nradstep=350,nwavestep=1024)
       REAL elam(nwavestep)
       REAL t(nwavestep,nradstep),s(nwavestep,nradstep)
       REAL td(nwavestep,nradstep),sd(nwavestep,nradstep)
       INTEGER thisline,blueline,rad,line,lline
       REAL ctheta(nradstep,21),sp,so
       REAL dr,rm
       REAL elamx(92,0:5),gfx(92,0:5),chix(92,0:5),taux(92,0:5,nradstep)
       REAL vphot,vmax
       REAL tbb
       REAL ea,eb
       REAL taumin,zeta,black(10000),wk,wk2,u
       LOGICAL flambda
       INTEGER grid,jrlim,nlam,krm,klam,iwk,step
       REAL in,drm,factor,tav,sav,stspec
       INTEGER an(50),ai(50),numref

       COMMON /param/ elamx,gfx,chix,taux,vphot,vmax,tbb,ea,eb
     a    ,taumin,zeta,grid,jrlim,nlam,flambda,an,ai,numref,stspec
       COMMON /radial/ t,td,s,sd
       IF (thisline.lt.blueline) THEN
          IWK=thisline+nwavestep
       ELSE
          IWK=thisline
       ENDIF
       factor=(exp(1./tbb/ea)-1.)*(ea/elam(thisline))*3
C  CALCULATE J FOR FIRST GRID LOCATION.
C  ASSUME THAT THE PHOTOSPHERE CONTRIBUTES .5 of the blackbody
C  SO WE ONLY HAVE TO WORRY ABOUT THE OUTSIDE STUFF.
       rad=grid+1
       IF ((t(thisline,rad)+t(thisline,rad+1)+t(thisline,rad-1))
     a       .gt.taumin) THEN  
          klam=INT(log(elam(thisline)/ea)/log(eb/ea)*(nlam-1))+1
          sp=.5*black(klam)*zeta*zeta
          so= 0.0
          wk=REAL(rad-1)/REAL(grid) 
          IF (blueline.lt.IWK)  THEN
            DO  step=11,20
C  
C  Modify the following line for toplighting.
C  
             in=0.0 
             DO line=blueline,IWK-1
              lline=MOD(line-1,nwavestep)+1
              dr=(elam(thisline)-elam(lline))/elam(thisline)*3.0e5/vphot
              rm=SQRT(wk*wk+dr*dr-2.*dr*wk*ctheta(rad,step))
              IF (rm.lt.vmax/vphot) THEN
                krm=INT(rm*REAL(grid))+1
                drm=rm*REAL(grid)-REAL(krm-1)
                tav=t(lline,krm)+drm*td(lline,krm)
                sav=s(lline,krm)+drm*sd(lline,krm)
                in=in*exp(-tav)+sav*(1.-exp(-tav))
     a             *(elam(lline)/elam(thisline))**3
              ENDIF
             ENDDO
             so=so+in
            ENDDO
            so=so/10.*.5
          ENDIF
 
C  NOW CALCULATE S,T FOR FIRST GRID LOCATION
          s(thisline,rad)=so+sp
          t(thisline,rad)=t(thisline,rad)
     a                    *(1.-1./(factor/s(thisline,rad)+1.))
        ELSE
          t(thisline,rad)=0.0
          s(thisline,rad)=0.0
        ENDIF

C  NOW CALCULATE J FOR THE REST OF THE GRID LOCATIONS
       DO rad=grid+2,jrlim
         IF (t(thisline,rad)+t(thisline,rad+1).gt.taumin) THEN
           sp= 0.0
           so= 0.0
           in= 0.0
           DO step=1,10
             wk=REAL(rad-1)/REAL(grid)
C  wk is the radius we are at
C  u is cos theta for this ray
             u=ctheta(rad,step)
             wk2=wk*u-SQRT(wk*wk*(u*u-1.)+1.)
             klam=INT(log(elam(thisline)*(1.-vphot*wk2/3.0e5)/ea)/
     a            log(eb/ea)*REAL(nlam-1))+1
             klam=MAX(klam,1)
             in=black(klam)*(1.-vphot*wk2/3.0e5)**3*zeta*zeta
             IF (blueline.lt.IWK) THEN
               DO line=blueline,IWK-1
                lline=MOD(line-1,nwavestep)+1
                dr=(elam(thisline)-elam(lline))/elam(thisline)
     a             *3.0e5/vphot
                rm=SQRT(wk*wk+dr*dr-2.*dr*wk*u)
                IF (rm.gt.1.and.u*dr.lt.wk) THEN
                  krm=INT(rm*REAL(grid))+1
                  drm=rm*REAL(grid)-REAL(krm-1)
                  tav=t(lline,krm)+drm*td(lline,krm)
                  sav=s(lline,krm)+drm*sd(lline,krm)
                  in=in*exp(-tav)+sav*(1.-exp(-tav))
     a               *(elam(lline)/elam(thisline))**3
                ENDIF
               ENDDO
             ENDIF
             sp=sp+in
           ENDDO
c NOW WE TAKE THE AVERAGE RAY AND MULTIPLY IT BY THE FRACTION OF SOLID ANGLE
C WHICH THE PHOTOSPHERE SUBTENDS
           sp=sp/10.*ctheta(rad,21)
C NOW WE MUST DO THE INTERACTION TERM FOR LINES AWAY FROM THE PHOTOSPHERE
           IF (blueline.lt.IWK) THEN  
             DO step=11,20
C  
C  Modify the following line for toplighting.
C  
               in=0.0
               DO line=blueline,IWK-1
                lline=MOD(line-1,nwavestep)+1
                dr=(elam(thisline)-elam(lline))/elam(thisline)
     a             *3.0e5/vphot
                rm=SQRT(wk*wk+dr*dr-2.*dr*wk*ctheta(rad,step))
                IF (rm.lt.vmax/vphot) THEN
                   krm=INT(rm*REAL(grid))+1
                   drm=rm*REAL(grid)-REAL(krm-1)
                   tav=t(lline,krm)+drm*td(lline,krm)
                   sav=s(lline,krm)+drm*sd(lline,krm)
                   in=in*exp(-tav)+sav*(1.-exp(-tav))
     a                *(elam(lline)/elam(thisline))**3
                ENDIF
               ENDDO
               so=so+in
             ENDDO
             so=so/10.*(1.-ctheta(rad,21))
           ENDIF
           s(thisline,rad)=so+sp
           t(thisline,rad)=t(thisline,rad)
     a                   *(1.-1./(factor/s(thisline,rad)+1.))
         ELSE
           s(thisline,rad)=0.0
           t(thisline,rad)=0.0
         ENDIF
           sd(thisline,rad-1)=s(thisline,rad)-s(thisline,rad-1)
           td(thisline,rad-1)=t(thisline,rad)-t(thisline,rad-1)

        ENDDO
C
C PRINT OUT J and TAU
C     
C       do rad = grid + 1, jrlim
C        wk = real( rad - 1 ) / real( grid ) * vphot
C        write( 100000 + thisline, * )
C    &         wk,s(thisline,rad),t(thisline,rad)
C       end do
C
        RETURN
      
        END
