       PROGRAM synnew
       
       PARAMETER (nradstep=350,nwavestep=1024)
       REAL elamx(92,0:5),gfx(92,0:5),chix(92,0:5),taux(92,0:5,nradstep)
       REAL vphot,vmax
       REAL tbb
       REAL ea,eb
       REAL taumin,zeta
       REAL elam(nwavestep)
       REAL t(nwavestep,nradstep) ,s(nwavestep,nradstep)
       REAL td(nwavestep,nradstep),sd(nwavestep,nradstep)
       REAL filparm(50,5) ,stspec
       INTEGER blueline,thisline,ifile
       INTEGER used,usedold,numref
       REAL black(10000),xplot(10000)
       REAL CTHETA(nradstep,21)
       INTEGER grid,jrlim,nlam,ffilenum,sfilenum,last,i,j
       INTEGER an(50),ai(50)
       LOGICAL flambda
 
       COMMON /param/ elamx,gfx,chix,taux,vphot,vmax,tbb,ea,eb
     a    ,taumin ,zeta,grid,jrlim,nlam,flambda,an,ai,numref,stspec
       COMMON /radial/ t,td,s,sd
!
       integer iflat        ! Jeffery hack 2006jul08.
       common/flat/iflat
!

c      READ IN INITIAL PHYSICAL PARAMETERS
       CALL INITIALIZE()
       blueline=1
       usedold=0
       used=0
C      SETUP TO READ PROPER LINE,FILE
       isto=int(log(ea/900.0)/log(1.001)/256.0)
       ea=900.*(1.001**256)**isto
       CALL BB(ea,eb,nlam,black,xplot,tbb)
       CALL THETA(ctheta,grid,jrlim)
 
       sfilenum=isto+1
       ffilenum=int(log(eb/900.0)/log(1.001)/256.0)+1
       IF (sfilenum.lt.2) THEN
         PRINT *,'EA TOO SMALL',ea
         stop
       ENDIF
       IF (ffilenum.gt.13) THEN
         PRINT *,'EB TOO BIG',eb
         stop
       ENDIF
       last=0
       DO i=1,nlam
        IF  (xplot(i).lt.stspec)  last=i
       ENDDO
C      READ IN NEXT BIN AND INITIALIZED OPTICAL DEPTHS
       DO ifile=sfilenum,ffilenum
        CALL FILE(taux,gfx,chix,an,ai,ifile,filparm,numref)
        PRINT *,'ON FILE ',ifile,' of ',ffilenum
        CALL GETBIN(elam,t,usedold,used,ifile,filparm)
        IF (ifile.eq.sfilenum) THEN
         DO i=1,used-1
          if (elam(i).lt.ea) then
            blueline=i+1
            thisline=i+1
            DO j=1,jrlim
             t(i,j)=0.0
             td(i,j)=0.0
            ENDDO
          ENDIF
         ENDDO
        ENDIF
        DO thisline=usedold+1,used
           if (elam(thisline).gt.eb) goto 555
 
c            PRINT *,elam(thisline),t(thisline,grid+1)
c          CALCULATE SOURCE FUNCTIONS FOR THIS LINE
           CALL SOURCE(elam,thisline,blueline,ctheta,black)

c          CALCULATE SPECTRUM
           IF (elam(thisline).gt.stspec) THEN
             CALL SPECTRUM (elam,thisline,blueline,xplot,black
     a       ,jrlim,grid,last,vmax,vphot,flambda,nlam,zeta,ea,eb)
           ENDIF
 
         ENDDO
          IF (used.gt.767) THEN
             
            PRINT *,'SHUFFLE',thisline,blueline,used,usedold

            DO is=blueline,used
               DO j=grid+1,jrlim
                t(is-blueline+1,j) = t(is,j)
                t(is,j)=0.0
                td(is-blueline+1,j)= td(is,j)
                s(is-blueline+1,j) = s(is,j)
                sd(is-blueline+1,j)= sd(is,j)
              ENDDO
              elam(is-blueline+1)=elam(is)
              elam(is)=1.1*eb
              t(is,4)=0.0
            ENDDO
            DO is=used-blueline+2,blueline
              DO j=grid+1,jrlim
                t(is,j)=0.0
              ENDDO
            ENDDO
            used=used-blueline+1
            thisline=thisline-blueline+1
              blueline=1 
          ENDIF
          usedold=used
        ENDDO
C       CALCULATE LAST BIT OF SPECTRUM.
 555    PRINT *,'ALMOST DONE'
  
        DO i=thisline,1024
         elam(i)=eb*10.0
        ENDDO
        CALL SPECTRUM (elam,thisline,blueline,xplot,black,jrlim,
     a grid,last,vmax,vphot,flambda,nlam,zeta,ea,eb)
!
        if(iflat .ne. 0) then      ! Jeffery hack 2006jul08.
            write(*,*) 'Before calling locnorm'
            close(unit=11)         ! This is apparently needed before the file can re-opened in locnorm.
            call locnorm(0,' ')
        end if
C                             END OF MAIN PROGRAM
        END
